<template>
  <div class="form_group_file">
    <label class="form_group_file_label" :for="inputId">
    <i class="material-icons">cloud_upload</i>
    <p>{{fileToUpload && fileToUpload.name}}</p>
    <p class="title" v-if="data.required">Drop file to upload, or <button @click.prevent>Browse</button></p>
    <input
      class="file_upload_input"
      :id="inputId"
      type="file"
      :disabled="disabled"
      @change="processFile($event)"
    />
    </label>
    <p v-for="error in errors" :key="error.id" class="error-message">{{error}}</p>
  </div>

</template>

<script>
export default {
  data() {
    return {
      fileToUpload: null,
    };
  },
  props: ['data', 'errors', 'inputId', 'value', 'input', 'disabled'],
  watch: {
    fileToUpload() {
      this.$emit('input').input(this.fileToUpload, this.inputId);
    },
  },
  methods: {
    processFile(event) {
      this.fileToUpload = event.target.files[0];
    },
  },
  mounted() {
    if (this.value === undefined) {
      this.fileToUpload = null;
      return;
    }
    this.fileToUpload = this.value;
  },
};

</script>

<style lang="scss">

.form_group_file {
  margin: 1em;
  margin-top: 3rem;
  position: relative;

  &_label{
    width: 100%;
    border: 2px dashed grey;
    border-radius: 5px;
    display: block;
    padding: 1.2em;
    transition: border 300ms ease;
    cursor: pointer;
    text-align: center;

    .title {
      margin: 0;
      button {
        pointer-events: none;
      }
      button:hover {
        color: #000;
        pointer-events: none;
        cursor: pointer;
      }
    }
    .file_upload_input:hover {
      cursor: pointer;
    }
    .file_upload_input {
      position: absolute;
      left: 0;
      top: 0;
      height: 100%;
      width: 100%;
      outline: 0;
      opacity: 0;
    }
    input[type="file"]::-webkit-file-upload-button {
      height: 100%;
      width: 100%;
    }
    i.material-icons {
      display: block;
      font-size: 50px;
      padding: 25px 0;
    }
    i,.title,button {
      color: grey;
      transition: 200ms color;
      }
    }
  &_label:hover {
    border:2px solid #000;
    cursor: pointer;
  }
  &_label:hover i, &_label:hover p {
    color:#000;
    cursor: pointer;
  }
}

</style>
